VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSerial"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Name As String
Private m_Email As String
Private m_Serial As String
Private m_AppName As String

Private m_Registered As Boolean
Private m_Cracked As Boolean
Private m_Version As String
Public Property Let AppName(m As String)
m_AppName = m
CheckSerial
End Property
Public Property Get AppName() As String
AppName = m_AppName
End Property
Public Function BuildSerial(Version As String) As String
'Serial format:
'XXXX-XXXX-XXXX-XXXX    All 4-digit Hex numbers
'Key1: Key(Name) + Key(App)
'Key2: Key(Email) + Key(App)
'Key3: Key(Name) + Key(Email)
'Key4: Key1 + Key2 + Key3 + Key(Ver)

'-------------------------------------------

Dim keyName As String, keyEmail As String, keyApp As String, keyVer As String
Dim Key1 As String, Key2 As String, Key3 As String, Key4 As String
    
keyApp = GetCheckValue(m_AppName, 10, 4) 'exp App key
keyName = GetCheckValue(m_Name, 5, 4)    'exp Name key
keyEmail = GetCheckValue(m_Email, 5, 4)  'exp Email key
Key1 = JoinKeys(keyName, keyApp, 4)  'expected Key1
Key2 = JoinKeys(keyEmail, keyApp, 4) 'expected Key2
Key3 = JoinKeys(keyName, keyEmail, 4)

Dim Key12 As String, Key123 As String
Key12 = JoinKeys(Key1, Key2, 4)
Key123 = JoinKeys(Key12, Key3, 4)
Key4 = JoinKeys(Key123, Key4, 4)

m_Serial = Key1 & "-" & Key2 & "-" & Key3 & "-" & Key4
BuildSerial = m_Serial
End Function
Public Sub CheckSerial()
'Serial format:
'XXXX-XXXX-XXXX-XXXX    All 4-digit Hex numbers
'Key1: Key(Name) + Key(App)
'Key2: Key(Email) + Key(App)
'Key3: Key(Name) + Key(Email)
'Key4: Key1 + Key2 + Key3 + Key(Ver)

'-------------------------------------------
'clear values
m_Registered = False
m_Cracked = False
m_Version = "0000"

'split serial
Dim asKeys() As String
asKeys = Split(m_Serial, "-")

'if not 4 keys, invalid
If UBound(asKeys) = 3 Then
    Dim keyName As String, keyEmail As String, keyApp As String, keyVer As String
    Dim Key1 As String, Key2 As String, Key3 As String, Key4 As String
    
    'reason this is ugly is don't want to load expected values until absolutely necessary in order to prevent cracker from looking at memory
    '[Join(A,B)=C] works like [A XOR B = C] therefore [A XOR C = B] and [B XOR C = A]
    
    keyApp = GetCheckValue(m_AppName, 10, 4) 'exp App key
    keyName = JoinKeys(asKeys(0), keyApp, 4) 'registered keyName
    keyEmail = JoinKeys(asKeys(1), keyApp, 4) 'registered keyEmail
    
    'check if third key is correct, with registered name/email
    Key3 = JoinKeys(keyName, keyEmail, 4)
    If Key3 = asKeys(2) Then
        'yes, so check if key values are correct
        keyName = GetCheckValue(m_Name, 5, 4)    'exp Name key
        keyEmail = GetCheckValue(m_Email, 5, 4)   'exp Email key
        Key1 = JoinKeys(keyName, keyApp, 4) 'expected Key1
        Key2 = JoinKeys(keyEmail, keyApp, 4) 'expected Key2
        'Key3 was correct so no need to recheck
        'Key4 is used to return registering version, so no need to check
        '    maybe later, check for valid versions
        
        'retrieve version
        Dim Key12 As String, Key123 As String
        Key12 = JoinKeys(Key1, Key2, 4)
        Key123 = JoinKeys(Key1, Key2, 4)
        m_Version = JoinKeys(Key123, Key4, 4)
        
        m_Registered = True
    End If
Else
    'not 4 keys
    m_Registered = False
End If
End Sub
Public Property Let Email(m As String)
m_Email = m
CheckSerial
End Property

Public Property Get Email() As String
Email = m_Email
End Property
Public Property Get Registered() As Boolean
Registered = m_Registered
End Property
Public Property Let Serial(m As String)
m_Serial = m
CheckSerial
End Property
Public Property Get Serial() As String
Serial = m_Serial
End Property
Public Property Let Name(m As String)
m_Name = m
CheckSerial
End Property
Public Property Get Name() As String
Name = m_Name
End Property
Public Sub SetInfo(Name As String, Email As String, Serial As String, AppName As String)
m_Name = Name
m_Email = Email
m_Serial = Serial
m_AppName = AppName
CheckSerial
End Sub
