Attribute VB_Name = "MTime"
Option Explicit

Public Enum ETEFormat
    eTE_Seconds = 1
    eTE_Minutes
    eTE_Hours
End Enum
Public Function TimeElapsed(ByVal TimeFrom As Date, ByVal TimeTo As Date, Optional TimeFormat As ETEFormat)
Dim tme As Date, s As Long, m As Long, h As Long
tme = TimeTo - TimeFrom

s = Second(tme)
m = Minute(tme)
h = Hour(tme)

Select Case TimeFormat
    Case eTE_Seconds
        TimeElapsed = s + 60 * m + 3600 * h
    Case eTE_Minutes
        TimeElapsed = m + 60 * h
    Case eTE_Hours
        TimeElapsed = h
End Select
End Function
