VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mCol As Collection
Private mFilename As String
Public Sub AddSetting(SettingName As String, SettingValue)
Dim Setting As CSetting
Set Setting = FindSetting(SettingName, True)
Setting.SettingValue = SettingValue
End Sub
Public Sub ClearSettings()
Set mCol = New Collection
End Sub
Public Property Let Filename(var As String)
mFilename = var
End Property
Public Property Get Filename() As String
Filename = mFilename
End Property
Private Function FindSetting(SettingName As String, Optional bCreate As Boolean = False) As CSetting
Dim i As Long, Setting As CSetting
For i = 1 To mCol.Count
    Set Setting = mCol.Item(i)
    If Setting.SettingName = SettingName Then
        Set FindSetting = Setting
        Exit Function
    End If
Next i

If bCreate Then
    Set Setting = New CSetting
    Setting.SettingName = SettingName
    mCol.Add Setting
    Set FindSetting = Setting
End If
End Function
Public Function GetSetting(SettingName As String, Optional Default)
Dim Setting As CSetting
Set Setting = FindSetting(SettingName)

If Setting Is Nothing Then
    GetSetting = Default
Else
    GetSetting = Setting.SettingValue
End If
End Function
Public Function LoadSettings() As Boolean
On Error GoTo ErrHandler

Dim iFF As Integer
iFF = FreeFile

ClearSettings

Open mFilename For Input As iFF
Dim inData As String, Setting As New CSetting

Do While Not EOF(iFF)
    Line Input #iFF, inData
    Setting.Data = inData
    AddSetting Setting.SettingName, Setting.SettingValue
Loop

Close #iFF

LoadSettings = True
Exit Function

ErrHandler:
LoadSettings = False

End Function
Public Function SaveSettings() As Boolean
On Error GoTo ErrHandler

Dim iFF As Integer
iFF = FreeFile

Open mFilename For Output As iFF
Dim i As Long, Setting As New CSetting
For i = 1 To mCol.Count
    Set Setting = mCol.Item(i)
    Print #iFF, Setting.Data
Next i

Close #iFF

SaveSettings = True
Exit Function

ErrHandler:
SaveSettings = False

End Function
