; The name of the installer
Name "emnify"		

; The file to write
OutFile "i-emnify.exe"	

; The default installation directory
InstallDir $PROGRAMFILES\doe\emnify

; Registry key to check for directory (so if you install again, it will overwrite the old one automatically)
InstallDirRegKey HKEY_LOCAL_MACHINE SOFTWARE\doe\emnify "Install_Dir"

; The text to prompt the user to enter a directory
ComponentText "This will install the less simple example2 on your computer. Select which optional things you want installed."
; The text to prompt the user to enter a directory
DirText "Choose a directory to install in to:"

; The stuff to install
Section "emnify"
; Set output path to the installation directory.
SetOutPath $INSTDIR
; Put file there
File "asxbar.ocx"
File "emnify.exe"
File "readme.txt"
File "history.txt"
; Write the installation path into the registry
WriteRegStr HKEY_LOCAL_MACHINE SOFTWARE\doe\emnify "Install_Dir" "$INSTDIR"
; Write the uninstall keys for Windows
WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\emnify" "DisplayName" "emnify (remove only)"
WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\emnify" "UninstallString" '"$INSTDIR\uninstall.exe"'

; optional section
Section "Start Menu Shortcuts"
CreateDirectory "$SMPROGRAMS\doe"
CreateDirectory "$SMPROGRAMS\doe\emnify"
CreateShortCut "$SMPROGRAMS\doe\emnify\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
CreateShortCut "$SMPROGRAMS\doe\emnify\emnify.lnk" "$INSTDIR\emnify.exe" "" "$INSTDIR\emnify.exe" 0


; uninstall stuff

UninstallText "This will uninstall emnify. Hit next to continue."
UninstallExeName "uninstall.exe"

; special uninstall section.
Section "Uninstall"
; remove registry keys
DeleteRegKey HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\Example2"
DeleteRegKey HKEY_LOCAL_MACHINE SOFTWARE\NSIS_Example2
; remove files
Delete $INSTDIR\asxbar.ocx
Delete $INSTDIR\history.txt
Delete $INSTDIR\readme.txt
Delete $INSTDIR\emnify.exe
; MUST REMOVE UNINSTALLER, too
Delete $INSTDIR\uninstall.exe
; remove shortcuts, if any.
Delete "$SMPROGRAMS\doe\emnify\*.*"
; remove directories used.
RMDir "$SMPROGRAMS\Example2"
RMDir "$INSTDIR"

; eof
